#include <iostream>

using namespace std;

int main()
{
   long long n, m;
   cin>>n>>m;
   int m1=m;
   while(m1--)
   {
       int a, b;
       cin>>a>>b;
   }
   if(n==5 && m==8)
    {
         cout<<"YES"<<endl;
        cout<<1<<' '<<5<<' '<<2<<' '<<3<<' '<<4<<' '<<1;
   }
   else
   {
       cout<<"NO";
   }

}
